#!/usr/bin/perl
# $Id: movieposterdb.t 3692 2010-01-14 20:14:43Z chris $

use strict;
use warnings;

my @tests = (
    sub {
	use WebService::MoviePosterDB;

	my $w = new WebService::MoviePosterDB("api_version" => 1);
	my $m = $w->search("Movie", 'imdb_code' => 32904, "width" => 300);

	die unless ($m);
	die unless ($m->imdb() == 32904);
	die unless ($m->title() eq "The Philadelphia Story");
	die unless ($m->year() eq "1940");
	die unless ($m->page());
	die unless ($m->posters());
	die unless (scalar @{$m->posters()} > 0);
	foreach (@{$m->posters()}) { die unless $_->image_location(); }
    }, 

    sub {
	use WebService::MoviePosterDB;
	
	my $w = new WebService::MoviePosterDB("api_version" => 1);
	my $m = $w->search("Movie", 'title' => "Goldfinger", "width" => 300);

	die unless ($m);
	die unless ($m->imdb() == 58150);
	die unless ($m->title() eq "Goldfinger");
	die unless ($m->year() eq "1964");
	die unless ($m->page());
	die unless ($m->posters());
	die unless (scalar @{$m->posters()} > 0);
	foreach (@{$m->posters()}) { die unless $_->image_location(); }
    },

    sub {
	use WebService::MoviePosterDB;
	
	my $w = new WebService::MoviePosterDB("api_version" => 1);
	my $m = $w->search("Movie", 'imdb_code' => "910970", "width" => 300);

	die unless ($m);
	die unless ($m->imdb() == 910970);
	die unless ($m->title() eq "WALL\x{b7}E");
	die unless ($m->year() eq "2008");
	die unless ($m->page());
	die unless ($m->posters());
	die unless (scalar @{$m->posters()} > 0);
	foreach (@{$m->posters()}) { die unless $_->image_location(); }
    },

#    sub {
#	use WebService::MoviePosterDB;
#	
#	my $w = new WebService::MoviePosterDB("api_version" => 1);
#	my $m = $w->search("Movie", 'title' => "WALL\x{b7}E", "width" => 300);
#
#	die unless ($m);
#	die unless ($m->imdb() == 910970);
#	die unless ($m->title() eq "WALL\x{b7}E");
#	die unless ($m->year() eq "2008");
#	die unless ($m->page());
#	die unless ($m->posters());
#	die unless (scalar @{$m->posters()} > 0);
#	foreach (@{$m->posters()}) { die unless $_->image_location(); }
#    },

    sub {
	use WebService::MoviePosterDB;

	my $w = new WebService::MoviePosterDB("api_version" => 2);
	my $m = $w->search("Movie", 'imdb_code' => 32904, "width" => 300);

	die unless ($m);
	die unless ($m->imdb() == 32904);
	die unless ($m->title() eq "The Philadelphia Story");
	die unless ($m->year() eq "1940");
	die unless ($m->page());
	die unless ($m->posters());
	die unless (scalar @{$m->posters()} > 0);
	foreach (@{$m->posters()}) { die unless $_->image_location(); }
    }, 

    sub {
	use WebService::MoviePosterDB;
	
	my $w = new WebService::MoviePosterDB("api_version" => 2);
	my $m = $w->search("Movie", 'title' => "Goldfinger", "width" => 300);

	die unless ($m);
	die unless ($m->imdb() == 58150);
	die unless ($m->title() eq "Goldfinger");
	die unless ($m->year() eq "1964");
	die unless ($m->page());
	die unless ($m->posters());
	die unless (scalar @{$m->posters()} > 0);
	foreach (@{$m->posters()}) { die unless $_->image_location(); }
    },

    sub {
	use WebService::MoviePosterDB;
	
	my $w = new WebService::MoviePosterDB("api_version" => 2);
	my $m = $w->search("Movie", 'imdb_code' => "910970", "width" => 300);

	die unless ($m);
	die unless ($m->imdb() == 910970);
	die unless ($m->title() eq "WALL\x{b7}E");
	die unless ($m->year() eq "2008");
	die unless ($m->page());
	die unless ($m->posters());
	die unless (scalar @{$m->posters()} > 0);
	foreach (@{$m->posters()}) { die unless $_->image_location(); }
    },

#    sub {
#	use WebService::MoviePosterDB;
#	
#	my $w = new WebService::MoviePosterDB("api_version" => 2);
#	my $m = $w->search("Movie", 'title' => "WALL\x{b7}E", "width" => 300);
#
#	die unless ($m);
#	die unless ($m->imdb() == 910970);
#	die unless ($m->title() eq "WALL\x{b7}E");
#	die unless ($m->year() eq "2008");
#	die unless ($m->page());
#	die unless ($m->posters());
#	die unless (scalar @{$m->posters()} > 0);
#	foreach (@{$m->posters()}) { die unless $_->image_location(); }
#    },

    );

printf "%d..%d\n", 1, scalar @tests;

foreach (@tests) {

    eval { &$_(); };

    if ($@) {
	print "not ok\n";
    } else {
	print "ok\n";
    }
}
